unit FlatMethodsU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFoo = class
  public
    procedure ShowInfo(const Info: String);
  end;

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    Foo: TFoo;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TFoo }

procedure TFoo.ShowInfo(const Info: String);
begin
  ShowMessageFmt('%s: %s', [ClassName, Info])
end;

var
  TFoo_Create: function (AClass: TClass; Alloc: Boolean): TFoo;
  //TFoo_Free: procedure (Handle: TFoo);
  TFoo_Destroy: procedure (Handle: TFoo);
  TFoo_ShowInfo: procedure (Handle: TFoo; const Info: String);

procedure TForm1.FormCreate(Sender: TObject);
begin
  Foo := TFoo_Create(TFoo, True);
  TFoo_ShowInfo(Foo, 'Called through a function pointer');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //TFoo_Free(Foo);
  TFoo_Destroy(Foo)
end;

initialization
  TFoo_Create := @TFoo.Create;
  TFoo_ShowInfo := @TFoo.ShowInfo;
  //TFoo_Free := @TFoo.Free;
  TFoo_Destroy := @TFoo.Destroy;
end.
