unit ButtonEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls;

type
  TMessageEvent = procedure(Sender: TComponent; var Msg: TMessage) of object;

  TButtonEx = class(TButton)
  private
    FOnMessage: TMessageEvent;
  protected
    procedure WndProc(var Message: TMessage); override;
  published
    property OnMessage: TMessageEvent read FOnMessage write FOnMessage;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TButtonEx]);
end;

{ TButtonEx }

procedure TButtonEx.WndProc(var Message: TMessage);
begin
  if Assigned(OnMessage) then
    OnMessage(Self, Message);
  //Do not call inherited window proc if you want to hide the message
  inherited;
end;

end.
